/*
##############################################################
   WATTMETR
##############################################################
   
   s zobrazenim na LCD a vystupem serioveho kanalu
   
   (c) Ivo Strasil 2004
   Wurmova 22
   602 00 Brno
   ivo.strasil@centrum.cz   
   
   Tento zdrojovy kod ani s jeho pomoci vytvoreni program 
   NENI volne siritelnym!
   
   P-O-Z-O-R: NUTNE VYPNOUT -Os OPTIMALIZACI JINAK NEJEDE
              DELENI TYPU LONG!!! POUZITA -O2
##############################################################
*/


#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <math.h>
#include "a2d.c"



/// DEFINICE HARDWARU
#define		TLACITKO	!(PIND&_BV(5))

#define LCD_RS 	_BV(6);
#define LCD_E 	_BV(7);
#define LCD_STROBE PORTD|=LCD_E;DelayUs(3);PORTD&=~LCD_E;

#define SYSCLK 8

void DelayUs (unsigned char c)
{
 int i;
 i=SYSCLK*c;
 i=(i >> 2);
 while (i) {
  i--;
 }
}

void DelayMs (unsigned int c)
{
 while (c) {
  c--;
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
  DelayUs(250);
 }
 
}

void uart_init(unsigned int baud)
{
 UBRRH=(unsigned char)(baud>>8);
 UBRRL=(unsigned char)(baud);
 UCSRA=(1<<UDRE);
 UCSRB=(1<<RXEN)|(1<<TXEN);
 UCSRC=128+6;
}

int uart_transmit(char c)
{
 if (c == '\n')
   uart_transmit('\r'); 
 while ( !( UCSRA & (1<<UDRE)) )
  ;
 UDR = c;
 return 0;
}
/*
unsigned char ReceiveByte( void )
{
	while ( !(UCSRA & (1<<RXC)) ); 	
	return UDR;
}
*/
void lcd_write(unsigned char c)
{
	PORTB = (PORTB & 0xF0) |  (c >> 4);
	LCD_STROBE
	PORTB = (PORTB & 0xF0) |  (c & 0x0F);
	LCD_STROBE
	DelayUs(40);
}

void lcd_clear(void)
{
	PORTD&=0xFF-LCD_RS; //LCD_RS = 0;
	lcd_write(0x01);
	DelayMs(2);
}

void
lcd_putcommand(unsigned char c)
{
	PORTD&=(unsigned char)~LCD_RS;
	lcd_write(c);
}


void
lcd_puts(const char * s)
{
	PORTD|=LCD_RS;
	while(*s)
		lcd_write(*s++);
}

void
lcd_putch(unsigned char c)
{
	PORTD|=LCD_RS;
	lcd_write(c);
}


void lcd_init(void)
{
	PORTD&=(unsigned char)~LCD_RS;	
	DelayMs(15);	// power on delay
	PORTB = 0x3;	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	DelayUs(100);
	LCD_STROBE;
	DelayMs(5);
	PORTB = 0x2;	// set 4 bit mode
	LCD_STROBE;
	DelayUs(40);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}


/// DEFINICE GLOBALNICH PROMENNYCH

volatile struct watt_data {
 unsigned long vzorek; //pocitadlo poctu mereni
 unsigned long PPlus,PMinus; //soucet okamz. P ve smeru ze/do zdroje
 unsigned long U2Cnt; //soucet druhych mocnin napeti
 unsigned short UMax,IMax; //max. dosazene napet a proud 
 signed short upolsum;
} aktdata,prenos,zpracuj;

unsigned static short kompdata[2]={512,512};

void nul_aktdata() {
 aktdata.vzorek=0;
 aktdata.PPlus=0;aktdata.PMinus=0;aktdata.U2Cnt=0;
 aktdata.UMax=0;aktdata.IMax=0;aktdata.upolsum=0;
}


unsigned char upolch=0; //pocitadlo casu od posledni zmeny znamenka U
unsigned char upol,upolov; //flagy znamenka okamz. U, UPolov je chraneny proti ruseni

// ovladani mericiho cyklu
volatile unsigned char je_vysledek=0; //flag ktery informuje o dostupnych novych datech
#define		IINPUT_NORMAL	1
#define		IINPUT_X10		0
#define	    IPROPREP		700
volatile unsigned char I_prekroc=10; //pokud Imax<IPROPREP, tak se odecte 1
                                     //az I_prekroc=0, tak se prepne I_input na IINPUT_X10
volatile unsigned char I_input=IINPUT_NORMAL;
#define		zadam_vzorku	600

// informace o ubehlem case v desitkach ms
unsigned char cas=0;
unsigned long sekund=0;

// informace o zmerene taktovaci frekvenci procesoru
unsigned int tmrtemp=8000000/256;

FILE * lcd; FILE * seriak;

/// HANDLER PRERUSENI CASOVACE 0 - nacita vzorky struktury watt_data
volatile signed short UTEMP=0;
volatile unsigned short ITEMPO=0;

volatile unsigned char kadr=1;
SIGNAL(SIG_OVERFLOW0)
{
 //zakaz preruseni
 cli(); 
 TCNT0=0x05;
 if (kadr) {
 //informuj o vstupu do preruseni na PD[2]
 PORTD=(unsigned char)PORTD|(0x04);
 /// 1.cast prerusovaci rutiny - nacteni okamzitych hodnot napeti a proudu
 signed short U1,U2;
 signed short I;
 //nacti napeti
 //1.vzorek napeti
 a2dSetChannel(2);
 a2dStartConvert();
 loop_until_bit_is_set(ADCSR, ADIF);
 sbi(ADCSR, ADIF);
 U1=a2dConvert10bit();
 //vzorek proudu
 a2dSetChannel(I_input);
 a2dStartConvert();
 loop_until_bit_is_set(ADCSR, ADIF);
 sbi(ADCSR, ADIF);
 I=a2dConvert10bit();
 //2.vzorek napeti
 a2dSetChannel(2);
 a2dStartConvert();
 //vyuzij volny cas na prepocet proudu do rozumne hodnoty
 // I je v [mA], pro plny rozsah je I=1,27(V)*6.8A=8.636A
 // I=8.636*1000*(I-512)/512*(1+9*I_input)
 // I=1686*(I-512)*(1+9*I_input)/1000
 loop_until_bit_is_set(ADCSR, ADIF);
 
 //zaokrouhli velmi nizke proudy k nule
 if (I>508&&I<516) {I=512;};
 signed long It=((signed long)I-kompdata[I_input])*4318*(1+3*I_input);
 It=It>>10;
 I=(signed short)It; 
 sbi(ADCSR, ADIF);
 U2=a2dConvert10bit();
 //prumer ze vzorku napeti a prepocet na U[x.1 V]
 //delic je v pomeru 330:1, tj. pro Uin=300V bude Uout=1.27+0.906
 //Uout[x.1V]=(U1-512)/512*344.17=(U1-512)*6722/1000
 U1=(U1+U2)>>1;
 U1=(signed short)((signed long)((8407*((signed long)U1-512))>>10)); //originalne *8407
 //U1=U1>>10;
  
 //detektor zmeny polarity
 if (upolch) {upolch--;}
 if ((((U1>0)!=upolov)&&(!upolch))) {
  upolch=10;
  upolov=U1>0;
  if (upolov) {
   if (I>200) {
    aktdata.upolsum++;
   };
   if (I<(signed int)-200) {
    aktdata.upolsum--;
   };
  }
  cas++;
  if (cas==100) {
   cas=0;
   sekund++;
   tmrtemp=TCNT1;
   TCNT1=0;
  }
  PORTB&=0xFF-16;
  if (upolov) {
   PORTB|=16;
  }
 }
 upol=U1>0;
 
 aktdata.vzorek++;
 
 //vypocet okamz. vykonu v .1 W
 //Pok=U.I=U[x.1]*I[x.001]/1000
 
 signed long Pok=(signed long)U1*(signed long)I;
 Pok=Pok/1000;
 //Pok=1000;
 if (Pok>0) {
  aktdata.PPlus+=Pok;
 }
 if (Pok<0) {
  aktdata.PMinus+=(-Pok);
 }
 signed short U; //do U abs(U1)
 if (U1>=0) {U=U1;} else
 {U=-(U1);}
 I=I>0?I:-I;				   //   I = abs(I) 
 if (I>aktdata.IMax) {aktdata.IMax=(unsigned short)I;}
 //U=20;
 U=U/10;
 aktdata.U2Cnt+=(unsigned long)U*(unsigned long)U;
 
 //az bude dost vzorku, zkopiruj aktdata do prenos (v nule U!!!)
 //a nastav flag je_vysledek
 //a vynuluj aktdata
 if (aktdata.vzorek>zadam_vzorku&&upolch==10) {
  prenos=aktdata;
  je_vysledek=1;
  
  if (I_input==IINPUT_NORMAL&&aktdata.IMax<IPROPREP) {
   I_prekroc--;
   if (!I_prekroc) {
    I_input=IINPUT_X10;
   }
  }
  if (I_input==IINPUT_X10&&aktdata.IMax>(IPROPREP+50)) {
   I_prekroc=8;
   I_input=IINPUT_NORMAL;
  }
  nul_aktdata();
 }


 //informuj o vstupu do preruseni na PD[2]
 PORTD=(unsigned char)PORTD&(0xFB);
 }
 kadr=1-kadr;
 //povol preruseni
 sei(); 
}

#define RCAS	0
#define RCOS	1
#define RJAL	2
#define RVA 	3
#define RI  	4
#define RU  	5
#define RSUM	6
#define RSUMKWH	7
#define RAVG	8
#define RCNT	8

unsigned long temp;

void vypis_temp_100(void) {
 fprintf_P(lcd,PSTR("%lu,%l.2u"),temp/100,temp%100);
}

void kompenzace(void) {
 unsigned short Isum;
 signed short Idelt=0;
 unsigned char inp,cnt;
 for (inp=0;inp<2;inp++) {
  Isum=0;
  for (cnt=0;cnt<8;cnt++) {
   //nacti vzorek proudu - 8x pro kazdy rozsah
   a2dSetChannel(inp);
   DelayMs(4);
   a2dStartConvert();
   loop_until_bit_is_set(ADCSR, ADIF);
   sbi(ADCSR, ADIF);
   Isum+=a2dConvert10bit();
   if (cnt%2) {
    Idelt+=a2dConvert10bit();
   } else {
    Idelt-=a2dConvert10bit();
   }   
  } 
  Isum=Isum>>3;  
  if (Idelt<20) {
   kompdata[inp]=Isum;
  } else {
   Idelt=200;
  }
 }
 if (Idelt<20&&(signed short)Idelt>(signed short)-20) {
  fprintf(lcd,"K%d/%d",(signed short)kompdata[0]-512,(signed short)kompdata[1]-512);
  
 } else {
  lcd_puts("K ERR");
  kompdata[0]=512;
 };
}

int main(void) {
 unsigned char rozsah=0;
 //INICIALIZACE
 //porty
 DDRB=0xFF;
 PORTB=0x00;
 DDRC=0x00;
 PORTC=0x00;
 DDRD=64+128+4;
 PORTD=0xFF;
 //dame 100ms na ustaleni napeti...
 DelayMs(100); 
 //AD prevodnik
 a2dInit();
 //LCD displej
 lcd_init();
 lcd=fdevopen(lcd_putch, NULL, 0);
 //seriovy kanal 
 uart_init(100); //stejne pak tu hodnotu zmenime
 seriak=fdevopen(uart_transmit, NULL, 0);
 //casovac 0
 // Timer/Counter 0 initialization
 // Clock source: System Clock
 // Clock value: 500,000 kHz
 TCCR0=0x02;
 TCNT0=0x06;
 TIMSK=0x01;
 // Timer/Counter 1 initialization
 // Clock source: System Clock
 // Clock value: 31,250 kHz
 // Mode: Normal top=FFFFh
 // OC1A output: Discon.
 // OC1B output: Discon.
 // Noise Canceler: Off
 // Input Capture on Falling Edge
 TCCR1A=0x00;
 TCCR1B=0x04;
 TCNT1=0;
 //informace na displej
 lcd_clear();
 fprintf_P(lcd,PSTR("MAX1.3kW"));
 lcd_putcommand(0xC0);
 fprintf_P(lcd,PSTR("v02 2004"));
 DelayMs(300);
 lcd_clear();
 fprintf_P(lcd,PSTR("Strasil"));
 lcd_putcommand(0xC0);
 //nastav kompenzaci nuly
 kompenzace();
 
 DelayMs(600);
 lcd_clear();
 
 nul_aktdata();
 //zapni preruseni (enablovano je od casovace 0)
 sei();
 unsigned long cinny=0,pcelkem=0,pcelkem2=0;
// a2dStartConvert();
 unsigned char tlcnt=0;
 unsigned long uef=0,lsekund=sekund;
 float ftemp;
 //vypni kurzor
 lcd_putcommand(0x0C);
 unsigned int baud;
 while (1)
 {
   if (je_vysledek) {
	   zpracuj=prenos;
	   je_vysledek=0;
	   baud=tmrtemp/75;
	   UBRRH=(unsigned char)(baud>>8);
       UBRRL=(unsigned char)(baud);
 
	   //odesli seriakem
       
	   if (TLACITKO) {
        tlcnt++;
	   }	
   }   
   
   DelayMs(50);
   
   //prekresli zobrazeni
   
   //vyber rozsahu
   if (TLACITKO) {
    tlcnt++;
   } else if (tlcnt) {
    if (tlcnt<12) {
	 lcd_clear();
	 rozsah++;
	 if (rozsah>RCNT) {rozsah=0;}
	} else if (rozsah==RCAS||rozsah==RAVG) {
	 //nuluj data
	 sekund=0;
	 pcelkem=0;
	 pcelkem2=0;
	}
	tlcnt=0;
   }
   //1.radek: cinny vykon
   
   if (zpracuj.PPlus<zpracuj.PMinus) {
    fprintf_P(lcd,PSTR(" < 0,0W"));
   } else {
    cinny=(zpracuj.PPlus-zpracuj.PMinus)/zpracuj.vzorek;
    if (lsekund!=sekund) {
     pcelkem+=cinny/10;
	 if (pcelkem>(unsigned long)360000000) {
	  pcelkem-=360000000;
	  pcelkem2++;
	 }
     if (rozsah==RU) {
	  fprintf_P(seriak,PSTR("%3lu;"),uef);	
     }	 
	 
	 fprintf_P(seriak,PSTR("%4lu,%u\n"),cinny/10,cinny%10);	   	   
	 
     lsekund=sekund;	 
	 lcd_clear();
    }   
	if (cinny<=13500) {
     fprintf_P(lcd,PSTR("%l4u,%uW"),cinny/10,cinny%10);
	 
	} else {
	 fprintf_P(lcd,PSTR("PRETIZEN"));
    }
   }
   if (I_input==IINPUT_X10) {
	  lcd_putch(0xA5);
   }	else {
       lcd_putch(' ');
   }
   
   //fprintf_P(lcd,PSTR("%lu"),cinny);
   //2.radek
   lcd_putcommand(0xC0);
   
   if (rozsah==RU||rozsah==RI) {
    //efekt.hodn.U
	temp=zpracuj.U2Cnt/zpracuj.vzorek;
	
	ftemp=sqrt((float)temp);
	uef=(unsigned long)floor(ftemp);
   }
   
   //vyber hodnoty podle [rozsah]
   
   if (rozsah==RCAS) {
    //cas mereni	
	if (sekund>=(unsigned long)1440*60) {
	 fprintf_P(lcd,PSTR("%.2lud%.2lu:%.2lu"),sekund/86400,(sekund/3600)%24,(sekund/60)%60);
	} else {	 
	 fprintf_P(lcd,PSTR("%.2lu:%.2lu:%.2lu"),sekund/3600,(sekund/60)%60,sekund%60);
	}
   } else if (rozsah==RCOS) {
    //cos phi
	temp=(zpracuj.PPlus-zpracuj.PMinus)*100/(zpracuj.PPlus+zpracuj.PMinus);
	if (temp<=101&&zpracuj.PPlus>30000) {
	 //pri cos>1 (zaporny ucinik - dojde k preteceni,..) nebo P<5W nevypisuj nic
	 lcd_putch('U');
	 if (zpracuj.upolsum>3) {
	  lcd_putch(0x7F);
	 } else
	 if (zpracuj.upolsum<(signed int)-3) {
	  lcd_putch(0x7E);
	 } else {
	  lcd_putch(' ');
	 }
	 lcd_putch('I');
     lcd_putch(' ');	 
	 vypis_temp_100();	 
	} else {
	 fprintf_P(lcd,PSTR("cos ----"));	 
	}
   } else if (rozsah==RJAL) {
    //jalovy vykon
	temp=zpracuj.PMinus/(zpracuj.vzorek>>1);
	if (zpracuj.PPlus>30000) {	 
	 //pri P<5W nic nevypisuj
     fprintf_P(lcd,PSTR("JAL%l4uW"),temp/10);
	} else {
	 fprintf_P(lcd,PSTR("JAL ----"));
	}
   } else if (rozsah==RVA) {
    //vykon ve VA
	temp=(zpracuj.PMinus+zpracuj.PPlus)/(zpracuj.vzorek);
	if (zpracuj.PPlus>30000) {	 
	 //pri P<5W nic nevypisuj
     fprintf_P(lcd,PSTR("%l4u VA"),temp/10);
	} else {
	 fprintf_P(lcd,PSTR("---- VA"));
	}
   } else if (rozsah==RU) {
	fprintf_P(lcd,PSTR("Uef %3luV"),uef);	
   } else if (rozsah==RI) {
    temp=(zpracuj.PMinus+zpracuj.PPlus)/(zpracuj.vzorek);
	temp=temp*10/uef; 
	fprintf_P(lcd,PSTR("Ief"));
	vypis_temp_100();	
	lcd_putch('A');
   } else if (rozsah==RSUM) {
    if (pcelkem<(unsigned long)999990000||pcelkem2) {
     fprintf_P(lcd,PSTR("\xF6%l5ukJ"),pcelkem/1000);	
	} else {
	 fprintf_P(lcd,PSTR("\xF6 >100MJ"),pcelkem/1000);	
	}
   } else if (rozsah==RSUMKWH) {
    temp=pcelkem/36000; //1 [temp]=0.01kWh
	temp+=10000*pcelkem2;
	if (temp<10000) {
     fprintf_P(lcd,PSTR("%l2u,%l.2ukWh"),temp/100,temp%100);		
	} else {
	 fprintf_P(lcd,PSTR("%l5ukWh"),temp);		
    }	
   } else if (rozsah==RAVG) {	
    if (sekund>4&&!pcelkem2&&pcelkem<400000000) { //max. 110kWh jinak by doslo k preteceni
	 temp=pcelkem*10/(sekund+1);
     fprintf_P(lcd,PSTR("\xF8%l4u,%luW"),temp/10,temp%10);		
	} else {
	 fprintf_P(lcd,PSTR("---,-W"));		
	}
   }				
  }
}
